# Overtaking

Բուդապեշտի օդանավակայանից դեպի Ֆորաս հյուրանոց գործում է մեկ ուղղություն ունեցող մեկ գծանի ճանապարհ։ Ճանապարհի երկարությունը  $L$ կիլոմետր է։

IOI 2023 ի կապակցությամբ, $N+1$ հատ ավտոբուս ուղևորվելու են այդ ճանապարհով։ Ավտոբուսները համարակալված են $0$-ից $N$ թվերով։ $i$-րդ ավտոբուսը ($0 \le i \lt N$) լքելու է օդանավակայանը $T[i]$-րդ վայրկյանին, և կարող է անցնել $1$ կիլոմետր $W[i]$ վայրկյանում։ $N$ համարի ավտոբուսը պահեստային է և կարող է անցնել $1$ կիլոմետր $X$ վայրկյանում։ $Y$ պահը երբ պահեստային ավտոբուսը լքելու է օդանավակայանը դեռ որոշված չէ։

Ճանապարհի վրա վազանցելը արգելվում է։ Բայց ավտոբուսների հերթականությունը կարող է փոխվել **վերադասավորման կայաններում**։ Կան $M$ հատ ($M \gt 1$) վերադասավորման կայաններ ճանապարհի տարբեր կետերում, որոնք համարակալված են $0$-ից $M - 1$ թվերով։
$j$-րդ վերադասավորման կայանը ($0 \le j \lt M$) գտնվում է օդանավակայանից $S[j]$ կիլոմետր հեռավորության վրա։ Վերադասավորման կայանները սորտավորված են օդանավակայանից հեռավորության աճման կարգով, այսինքն, $S[j] \lt S[j+1]$, որտեղ $0 \le j \le M - 2$։ Առաջին վերադասավորման կայանը օդանավակայանն է իսկ վերջինը հյուրանոցը, այսինքն, $S[0] = 0$ և $S[M-1] = L$։

Ավտոբուսը շարժվում է իր մաքսիմալ արագությամբ, եթե իր դիմաց այլ ավտոբուս չկա, հակառակ դեպքում ավտոբուսը շարժվում է իրեն խանգարող ավտոբուսի արագությամբ, միչև հաջորդ վերադասավորման կայանը հասնելը։ Վերադասավորման կայանում արագ ավտոբուսները առաջ են անցնում դանդաղ ավտոբուսներից։

Ֆորմալ, բոլոր $i$ և $j$ ինդեքսների համար, որտեղ $0 \le i \le N$ և $0 \le j \lt M$, $t_{i,j}$ ժամանման պահը (վայրկյաններով) երբ $i$ ավտոբուսը **ժամանում** է $j$ վերադասավորման կայան սահմանված է հետևյալ ձևով։ $t_{i,0} = T[i]$, որտեղ $0 \le i \lt N$, և $t_{N,0} = Y$։
Ամեն $j$-ի համար, որտեղ $0 \lt j \lt M$․
* Սահմանենք $i$ ավտոբուսի $j$ կայան **ժամանման սպասված պահ** (վայրկյաններով), նշանակենք $e_{i,j}$, որպես այն ժամանակը որում $i$ ավտոբուսը կհասներ $j$ կայան, եթե շարժվեր իր մաքսիմալ արագությամբ նախորդ կայան հասնելու պահից սկսզծ։ Այսինքն․
  - $e_{i,j} = t_{i,j-1} + W[i] \cdot (S[j]-S[j-1])$ ($0 \le i \lt N$), և
  - $e_{N,j} = t_{N,j-1} + X \cdot (S[j]-S[j-1])$.
* $i$ ավտոբուսը կհասնի $j$ կայան իր և իրենից առաջ $j-1$ կայան հասած ավտոբուսների ժամանման սպասված պահերի *մաքսիմումին* հավասար պահին։ Ֆորմալ, $t_{i,j}$ հավասար կլինի $e_{i,j}$-ի և բոլոր $e_{k,j}$-ների մաքսիմումին, որոնց համար $0 \le k \le N$ և $t_{k,j-1} \lt t_{i,j-1}$.

IOI-ի կազմակերպիչները ուզում են որոշել պահեստային ավտոբուսի օդանավակայանը լքելու պահը։ Ձեր խնդիրն է պատասխանել $Q$ հատ հարցման, որոնք ունեն հետևյալ ֆորմատը․ տրված է $Y$ պահը (վայրկյաններով) երբ $N$ համարի ավտոբուսը պետք է լքի օդանավակայանը, ո՞ր պահին այն կհասնի հյուրանոց։

## Իրականացման մանրամասներ

Դուք պետք է ծրագրավորեք հետևյալ ֆունկցիան։

```
void init(int L, int N, int64[] T, int[] W, int X, int M, int[] S)
```

* $L$․ ճանապարհի երկարությունը։
* $N$․ ոչ պահեստային ավտոբուսների քանակը։
* $T$․ $N$ երկարության զանգված, որը նկարագրում է ոչ պահեստային ավտոբուսների օդանավակայանը լքելու ժամանակները։
* $W$․ $N$ երկարության զանգված որը նկարագրում է ոչ պահեստային ավտոբուսների արագությունները․
* $X$․ այն ժամանակը, որը պահանջվում է պահստային ավտոբուսին $1$ կիլոմետր անցնելու համար։
* $M$․ Վերադասավորման կայանների քանակը։
* $S$․ $M$ երկարության զանգված, որը նկարագրում է տեսակավորման կայանների հեռավորությունները օդանավակայանից։
* Այս ֆունկցիան կանչվում է ճիշտ մեկ անգամ, `arrival_time` ֆունկցիաի կանչերից առաջ։

```
int64 arrival_time(int64 Y)
```

* $Y$․ պահեստային ավտոբուսի օդանավակայանը լքելու ժամանակը։
* Այս ֆունկցիան պետք է վերադարձնի $N$ համարի ավտոբուսի հյուրանոց հասնելու ժամանակը։
* Այս ֆունկցիան կանչվում է ճիշտ $Q$ անգամ։

## Օրինակ

Դիտարկենք կանչերի հետևյալ հաջորդականությունը․

```
init(6, 4, [20, 10, 40, 0], [5, 20, 20, 30], 10, 4, [0, 1, 3, 6])
```

$4$-րդ ավտոբուսը հաշվի չառած (դրա լքման ժամանակը դեռ հայտնի չէ), հետևյալ աղյուսակը նկարագրում է ավտոբուսների ժամանման սպասծ և փաստացի պահերը համապատասխան կայաններ․

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:---------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $55$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$

$0$ կայան ժամանման ժամանակները համնկնում են օդանավակայանը լքելու ժամանակների հետ։ Այսինքն, $t_{i,0} = T[i]$ ($0 \le i \le 3$):

$1$ կայան ավտոբուսների ժամանման սպասվող և փաստացի ժամանակները հաշվվում են հետևյալ ձևով․
  - Ավտոբուս $0$. $e_{0,1} = t_{0,0} + W[0] \cdot (S[1]-S[0]) = 20 + 5 \cdot 1 = 25$:
  - Ավտոբուս $1$. $e_{1,1} = t_{1,0} + W[1] \cdot (S[1]-S[0]) = 10 + 20 \cdot 1 = 30$:
  - Ավտոբուս $2$. $e_{2,1} = t_{2,0} + W[2] \cdot (S[1]-S[0]) = 40 + 20 \cdot 1 = 60$:
  - Ավտոբուս $3$. $e_{3,1} = t_{3,0} + W[3] \cdot (S[1]-S[0]) = 0 + 30 \cdot 1 = 30$:
* $1$ կայան հասնելու փաստացի ժամանակները․
  - $1$ և $3$ ավտոբուսները հասնում են $0$ կայան ավելի շուտ քան $0$ ավտոբուսը, այսպիսով $t_{0,1} = \max([e_{0,1},e_{1,1},e_{3,1}]) = 30$:
  - $3$ ավտոբուսը հասնում է $0$ կայան ավելի շուտ քան $1$ ավտոբուսը, այսպիսով $t_{1,1} = \max([e_{1,1},e_{3,1}]) = 30$:
  - $0$, $1$ և $3$ ավտոբուսները հասնում են $0$ կայան ավելի շուտ քան $2$ ավտոբուսը, այսպիսով $t_{2,1} = \max([e_{0,1},e_{1,1},e_{2,1},e_{3,1}]) = 60$:
  - $0$ կայան $3$ ավտոբուսից ավելի արագ ոչ մի ավտոբուս չի հասնում, այսպիսով $t_{3,1} = \max([e_{3,1}]) = 30$:

```
arrival_time(0)
```

$4$ ավտոբուսից պահանջվում է $10$ վայրկյան $1$ կիլոմետր անցնելու համար և այս հարցման մեջ այն լքում է օդանավակայանը $0$-րդ վայրկյանին։ Այդ դեպքում, հետևյալ աղյուսակը նկարագրում է ավտոբուսների ժամանման ժամանակները։ Առաջացած փոփոխությունների ներքևում գիծ է քաշված։

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:-----------------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $\underline{60}$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$
$4$ || $0$       || $10$      | $10$      || $30$      | $30$      || $60$      | $60$

Նկատում ենք, որ $4$ ավտոբուսը հյուրանոց է հասնում $60$-րդ վայրկյանին։ Այսինքն, ֆունկցիան պետք է վերադարձնի $60$։

```
arrival_time(50)
```

Այս հարցման մեջ $4$ ավտոբուսը լքում է օդանավակայանը $50$-րդ վայրկյանին։ Այս դեքում սկզբնական աղյուսակում փոփոխություններ չկան։ Հետևյալ աղյուսակը նկարագրում է ժամանման ժամանակները։

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:---------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $55$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$
$4$ || $50$      || $60$      | $60$      || $80$      | $90$      || $120$     | $130$

$4$ ավտոբուսը վազանցում է ավելի դանդաղ $2$ ավտոբուսին $1$ տեսակավորման կայանում քանի, որ նրանք ժամանում են նույն պահին։ Այնուհետև, $4$ ավտոբուսը լռվում է $3$ ավտոբուսի հետևում $1$ կայանից $2$ կայան ճանապարհին, որի արդյունքւոմ $4$ ավտոբուսը հասնում է $2$ կայան $90$-րդ վայրկյանին $80$-ի փոխարեն։ $2$ կայանը լքելուց հետո, $4$ ավտոբուսը լռվում է $1$ ավտոբուսի հետևում մինչև հյուրանոց հասնելը. $4$ ավտոբուսը հյուրանոց է հասնում  $130$-րդ վայրկյանին։ Այսպիսով, ֆունկցիան պետք է վերադարձնի $130$։

Կարելի է գծագրել ավտոբուսների ժամանման ժամանակները կախված իրենց անցած ճանապարհից։ x-երի առանցքը ներկայացնում է ավտոբուսի անցած ճանապարհը (կիլոմետրերով), իսկ y-ների առանցքը ներկայացնում է ժամանակը (վայրկյաններով)։ Ուղղահայաց  կետագծերը ներկայացնում են տեսակավորման կայանները։ Գունավոր գծերը ներկայացնում են ոչ պահեստային ավտոբուսները իսկ
սև կետագիծը ներկայացնում է պահեստային ավտոբուսը:

 `arrival_time(0)`               | `arrival_time(50)`
:-------------------------------:|:------------------------------:
![](overtaking-query1-new.png)   | ![](overtaking-query2-new.png)

## Սահմանափակումներ

* $1 \le L \le 10^9$
* $1 \le N \le 1\,000$
* $0 \le T[i] \le 10^{18}$ ($0 \le i \lt N$)
* $1 \le W[i] \le 10^9$ ($0 \le i \lt N$)
* $1 \le X \le 10^9$
* $2 \le M \le 1\,000$
* $0 = S[0] \lt S[1] \lt \cdots \lt S[M-1] = L$
* $1 \le Q \le 10^6$
* $0 \le Y \le  10^{18}$

## Ենթախնդիրներ

1. (9 միավոր) $N = 1, Q \le 1\,000$
1. (10 միավոր) $M = 2, Q \le 1\,000$
1. (20 միավոր) $N, M, Q \le 100$
1. (26 միավոր) $Q \le 5\,000$
1. (35 միավոր) Լրացուցիչ սահմանափակումներ չկան։

## Գրեյդերի նմուշ

Գրեյդերի նմուշը մուտքային տվյալները կարդում է հետևյալ ձևաչափով․

* տող $1$․ $L \; N \; X \; M \; Q$
* տող $2$․ $T[0] \; T[1] \; \ldots \; T[N-1]$
* տող $3$․ $W[0] \; W[1] \; \ldots \; W[N-1]$
* տող $4$․ $S[0] \; S[1] \; \ldots \; S[M-1]$
* տող $5 + k$ ($0 \le k \lt Q$)․ $Y$-ը $k$ հարցման համար

Գրեյդերի նմուշը պատասխանները տպում է հետևյալ ձևաչափով․

* տող $1 + k$ ($0 \le k \lt Q$)․ $k$ հարցման համար `arrival_time`-ի վերադարձրած արժեքը։
