# Ötmə
Budapeşt hava limanından Forras Otelinə bir zolaqlı, birtərəfli yol var. Bu yolun uzunluğu $L$ kilometrdir.

IOI 2023 tədbiri ərzində $N+1$ daşıma avtobusu bu yoldan keçir. Avtobuslar $0$-dan $N$-ə nömrələnib.
$i$ ($0 \le i \lt N$) nömrəli avtobusun tədbirin $T[i]$-ci saniyəsində hava limanını tərk etməsi planlaşdırılıb və o $W[i]$ saniyədə $1$ kilometr yol qət edə bilər.
$N$ nömrəli avtobus ehtiyat avtobusdur və o $X$ saniyədə $1$ kilometr yol qət edə bilər.
Onun hava limanını tərk edəcəyi $Y$ vaxtı hələ müəyyən edilməyib.

Ümumilikdə yolda ötməyə icazə verilmir, lakin **sıralama məntəqələrində** avtobusların bir-birini ötməsinə icazə verilir.
Yolda müxtəlif mövqelərdə $0$-dan $M - 1$-ə nömrələnmiş $M$ ($M \gt 1$) sıralama məntəqəsi var.
$j$ ($0 \le j \lt M$) nömrəli sıralama məntəqəsi hava limanından yol boyunca $S[j]$ kilometr aralıda yerləşir.
Sıralama məntəqələri hava limanından artan məsafədə çeşidlənib, yəni hər $0 \le j \le M - 2$ üçün $S[j] \lt S[j+1]$.
Birinci sıralama məntəqəsi hava limanı, sonuncusu isə oteldir, yəni $S[0] = 0$ və $S[M-1] = L$.

Hər bir avtobus, yolda ondan qabaqda gedən daha yavaş avtobusa çatmadığı müddətcə, maksimum sürətlə hərəkət edir. Yavaş avtobusa çatdıqda isə onlar bir yerə yığılır və növbəti sıralama məntəqəsinə çatana qədər daha yavaş olan avtobusun sürəti ilə hərəkət etməyə məcbur olurlar. 
Orada daha sürətli avtobuslar daha yavaş avtobusları ötəcək.


Formal olaraq, hər bir $i$ ($0 \le i \le N$) və $j$ ($0 \le j \lt M$) üçün $i$ nömrəli avtobusun $j$ məntəqəsinə **çatma vaxtı** $t_{i,j}$ (saniyələrlə) aşağıdakı kimi təyin olunur.
Gəlin $t_{i,0} = T[i]$ ($0 \le i \lt N$) və $t_{N,0} = Y$ işarə edək.
$0 \lt j \lt M$ aralığındakı hər bir $j$ üçün:
* $i$ avtobusunun $j$ sıralama məntəqəsinə **gözlənilən çatma vaxtını** (saniyələrlə) $e_{i,j}$ ilə işarələyək. $e_{i,j}$, $i$ avtobusu $j-1$-ci sıralama məntəqəsinə çatdığı vaxtdan sonra tam sürətlə hərəkət etdiyi halda onun $j$ məntəqəsinə çatacağı vaxtı bildirir. Yəni:
  - $e_{i,j} = t_{i,j-1} + W[i] \cdot (S[j]-S[j-1])$ ($0 \le i \lt N$) və
  - $e_{N,j} = t_{N,j-1} + X \cdot (S[j]-S[j-1])$.

* $i$ avtobusu $j$-ci sıralama məntəqəsinə $i$ avtobusunun və $j-1$-ci sıralama məntəqəsinə ondan daha əvvəl çatan avtobusların gözlənilən çatma vaxtlarının *maksimumunda* çatır. Formal olaraq, $t_{i,j}$, $0 \le k \le N$, $t_{k,j-1} \lt t_{i,j-1}$ şərtlərini ödəyən $e_{k,j}$-lər və $e_{i,j}$-nin maksimumudur.

IOI təşkilatçıları ehtiyat avtobusun ($N$ nömrəli avtobus) hava limanını tərk etmə vaxtını təyin etmək istəyir. 
Sizin tapşırığınız təşkilatçıların aşağıdakı formada olan $Q$ sorğusuna cavab verməkdir: ehtiyat avtobusun hava limanını tərk etmə vaxtının $Y$ (saniyələrlə) olduğunu nəzərə alsaq, o, otelə nə vaxt çatacaq?

## İmplementasiya Detalları

Sizin tapşırığınız aşağıdakı prosedurları implement etməkdir.

```
void init(int L, int N, int64[] T, int[] W, int X, int M, int[] S)
```

* $L$: yolun uzunluğu.
* $N$: ehtiyatda olmayan avtobusların sayı.
* $T$: ehtiyatda olmayan avtobusların hava limanını planlaşdırılmış tərk etmə vaxtlarını təsvir edən $N$ uzunluqlu massiv.
* $W$: ehtiyatda olmayan avtobusların maksimum sürətini təsvir edən $N$ uzunluqlu massiv.
* $X$: ehtiyat avtobusun $1$ kilometr getməsi üçün lazım olan vaxt.
* $M$: sıralama məntəqələrinin sayı.
* $S$: sıralama məntəqələrinin hava limanından məsafələrini təsvir edən $M$ uzunluqlu massiv.
* Bu prosedur hər bir testdə `arrival_time` proseduruna hər hansı çağırış etməzdən əvvəl yalnız və yalnız bir dəfə çağırılır.

```
int64 arrival_time(int64 Y)
```

* $Y$: ehtiyat avtobusun ($N$ nömrəli avtobus) hava limanını tərk etməli olduğu vaxt.
* Bu prosedur ehtiyat avtobusun otelə çatacağı vaxtı qaytarmalıdır.
* Bu prosedur $Q$ dəfə çağırılır.

## Nümunə

Aşağıdakı çağırışları nəzərdən keçirin:

```
init(6, 4, [20, 10, 40, 0], [5, 20, 20, 30], 10, 4, [0, 1, 3, 6])
```

$4$ nömrəli (hələ planlaşdırılmamış) avtobusu nəzərə almadan, aşağıdakı cədvəldə ehtiyatda olmayan avtobusların hər bir sıralama məntəqəsinə gözlənilən və faktiki çatma vaxtları göstərilir:

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:---------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $55$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$

$0$ məntəqəsinə çatma vaxtları avtobusların hava limanını tərk etməsinin planlaşdırıldığı vaxtlardır. Yəni ki, $t_{i,0} = T[i]$  ($0 \le i \le 3$).

$1$ nömrəli sıralama məntəqəsinə gözlənilən və faktiki çatma vaxtları aşağıdakı kimi hesablanır:
* $1$ nömrəli məntəqəyə gözlənilən çatma vaxtları:
  - Avtobus $0$: $e_{0,1} = t_{0,0} + W[0] \cdot (S[1]-S[0]) = 20 + 5 \cdot 1 = 25$.
  - Avtobus $1$: $e_{1,1} = t_{1,0} + W[1] \cdot (S[1]-S[0]) = 10 + 20 \cdot 1 = 30$.
  - Avtobus $2$: $e_{2,1} = t_{2,0} + W[2] \cdot (S[1]-S[0]) = 40 + 20 \cdot 1 = 60$.
  - Avtobus $3$: $e_{3,1} = t_{3,0} + W[3] \cdot (S[1]-S[0]) = 0 + 30 \cdot 1 = 30$.
* $1$ nömrəli məntəqəyə faktiki çatma vaxtları:
  - $1$ və $3$ nömrəli avtobuslar $0$ məntəqəsinə $0$ nömrəli avtobusdan daha tez çatır, beləcə $t_{0,1} = \max([e_{0,1},e_{1,1},e_{3,1}]) = 30$.
  - $3$ nömrəli avtobus $0$ məntəqəsinə $1$ nömrəli avtobusdan daha tez çatır, beləcə $t_{1,1} = \max([e_{1,1},e_{3,1}]) = 30$.
  - $0$, $1$ və $3$ nömrəli avtobuslar $0$ məntəqəsinə $2$ nömrəli avtobusdan daha tez çatır, beləcə $t_{2,1} = \max([e_{0,1},e_{1,1},e_{2,1},e_{3,1}]) = 60$.
  - Heç bir avtobus $0$ məntəqəsinə $3$ nömrəli avtobusdan tez çatmır, beləcə $t_{3,1} = \max([e_{3,1}]) = 30$.

```
arrival_time(0)
```

$4$ nömrəli avtobusun $1$ kilometr qət etməsi $10$ saniyə çəkir və indi onun hava limanını $0$-cı saniyədə tərk etməsi planlaşdırılır.
Bu halda, aşağıdakı cədvəldə hər bir avtobusun çatma vaxtları göstərilir.
Ehtiyatda olmayan avtobusların gözlənilən və faktiki çatma vaxtları ilə bağlı yeganə dəyişiklik altdan xətt ilə işarələnib.

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:-----------------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $\underline{60}$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$
$4$ || $0$       || $10$      | $10$      || $30$      | $30$      || $60$      | $60$

Görürük ki, $4$ nömrəli avtobus $60$-cı saniyədə otelə çatır.
Beləliklə, prosedur $60$ qaytarmalıdır.

```
arrival_time(50)
```

$4$ nömrəli avtobusun indi hava limanını $50$-ci saniyədə tərk etməsi planlaşdırılır.
Bu halda ehtiyatda olmayan avtobusların çatma vaxtlarında ilkin cədvəllə müqayisədə heç bir dəyişiklik yoxdur.
Çatma vaxtları aşağıdakı cədvəldə göstərilmişdir.

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:---------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $55$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$
$4$ || $50$      || $60$      | $60$      || $80$      | $90$      || $120$     | $130$

$4$ nömrəli avtobus $1$ məntəqsində həmin məntəqəyə onunla eyni vaxtda çatan və ondan daha yavaş olan $2$ nömrəli avtobusu ötür. 
Daha sonra, $4$ nömrəli avtobus $1$ və $2$ məntəqələri arasında $3$ nömrəli avtobusla bir yerə yığılır, buna görə də $4$ nömrəli avtobus $80$-ci saniyə əvəzinə $90$-cı saniyədə $2$ məntəqəsinə çatır.
$2$ məntəqəsini tərk etdikdən sonra $4$ nömrəli avtobus otelə çatana kimi $1$ nömrəli avtobusla bir yerə yığılır.
$4$ nömrəli avtobus otelə $130$-cu saniyədə çatır.
Beləliklə, prosedur $130$ qaytarmalıdır.

Hər bir avtobusun hava limanından hər bir məsafəyə çatması üçün lazım olan vaxtın qrafikini göstərə bilərik.
Qrafikdə **x** oxu hava limanından olan məsafəni (kilometrlərlə) **y** oxu isə zamanı (saniyələrlə) ifadə edir.
Şaquli qırıq-qırıq xətlər sıralama məntəqələrinin yerlərini göstərir. 
Müxtəlif rəngli kəsintisiz xətlər (yanında avtobus nömrəsi qeyd olunmaqla) dörd ədəd ehtiyatda omayan avtobusları ifadə edir.
Nöqtəli qara xətt ehtiyatda olan avtobusu bildirir.

 `arrival_time(0)`               | `arrival_time(50)`
:-------------------------------:|:------------------------------:
![](overtaking-query1-new.png)   | ![](overtaking-query2-new.png)

## Məhdudiyyətlər

* $1 \le L \le 10^9$
* $1 \le N \le 1\,000$
* $0 \le T[i] \le 10^{18}$ ($0 \le i \lt N$)
* $1 \le W[i] \le 10^9$ ($0 \le i \lt N$)
* $1 \le X \le 10^9$
* $2 \le M \le 1\,000$
* $0 = S[0] \lt S[1] \lt \cdots \lt S[M-1] = L$
* $1 \le Q \le 10^6$
* $0 \le Y \le  10^{18}$

## Alt tapşırıqlar

1. (9 bal) $N = 1, Q \le 1\,000$
1. (10 bal) $M = 2, Q \le 1\,000$
1. (20 bal) $N, M, Q \le 100$
1. (26 bal) $Q \le 5\,000$
1. (35 bal) Əlavə məhdudiyyət yoxdur.

## Nümunə Qreyder

Nümunə qreyder giriş verilənlərini aşağıdakı formatda oxuyur:

* sətir $1$: $L \; N \; X \; M \; Q$
* sətir $2$: $T[0] \; T[1] \; \ldots \; T[N-1]$
* sətir $3$: $W[0] \; W[1] \; \ldots \; W[N-1]$
* sətir $4$: $S[0] \; S[1] \; \ldots \; S[M-1]$
* sətir $5 + k$ ($0 \le k \lt Q$): $k$-cı sorğu üçün $Y$ 


Nümunə qreyder sizin cavablarınızı aşağıdakı kimi çap edir:

* sətir $1 + k$ ($0 \le k \lt Q$): $k$-cı sorğu üçün `arrival_time` prosedurundan qayıdan dəyər
