# Overtaking

Það er einstefndur vegur með einni akrein frá flugvellinum í Budapest að hótelinu Forrás. Vegurinn er $L$ kílómetrar að lengd.

Á meðan IOI 2023 stendur yfir munu $N+1$ rútur keyra þennan veg.
Rúturnar eru númeraðar frá $0$ upp í $N$.
Rúta númer $i$, þar sem $0 \le i \lt N$, á að leggja af stað frá flugvellinum á $T[i]$-tu sekúndu atburðarins, og getur ferðast $1$ kílómetra á $W[i]$ sekúndum.
Rúta $N$ er vararúta sem getur ferðast $1$ kílómetra á $X$ sekúndum.
Ekki er búið að ákvarða á hvaða tíma $Y$ vararútan mun leggja af stað frá flugvellinum.

Framúrakstur er ekki leyfilegur á veginum almennt séð, en rúturnar mega taka fram út hvorri annarri á **röðunarstöðvum**.
Það eru $M$, þar sem $M \gt 1$, röðunarstöðvar á mismunandi stöðum á veginum, sem eru númeraðar frá $0$ upp í $M-1$.
Röðunarstöð númer $j$, þar sem $0 \le j \lt M$, er staðsett $S[j]$ kílómetrum frá flugvellinum meðfram veginum.
Röðunarstöðvar eru raðaðar í hækkandi fjarlægð frá flugvellinum, það er, $S[j] \lt S[j+1]$ fyrir sérhvert $0 \le i \le M-2$.
Fyrsta röðunarstöðin er á flugvellinum og síðasta röðunarstöðin er á hótelinum.
Þannig $S[0] = 0$ og $S[M-1] = L$.

Sérhver rúta ferðast á hámarkshraða sínum, nema ef hún nær hægari rútu sem er á undan sér á veginum. Í því tilviki fylkjast þær saman og þurfa að ferðast saman á hámarkshraða hægari rútunnar þar til þær komast á næstu röðunarstöð.
Þar munu hraðari rúturnar taka fram úr þeim hægari.

Formlega má segja, fyrir sérhvert $i$ og $j$ ar sem $0 \le i \le N$ og $0 \le j \lt M$ að tíminn $t_{i,j}$, í sekúndum, er tímasetningin sem rúta $i$ **kemur að** röðunarstöð $j$ sem er skilgreind á eftirfarandi máta.
Ef $j = 0$, látum við $t_{i,0} = T[i]$ fyrir sérhvert $i \lt N$ og látum $t_{N,0} = Y$.
Annars, fyrir sérhvert $j$ þar sem $0 \le j \lt M$:
* Skilgreinum *væntan komutíma* rútu $i$ að röðunarstöð $j$ sem tímann sem rúta $j$ myndi koma að röðunarstöð $j$ ef hún ferðaðist á fullum hraða frá tímanum sem hún kom að röðunarstöð $j-1$. Það er, látum
	- $e_{i,j} = t_{i,j-1} + W[i] \cdot (S[j]-S[j-1])$ fyrir sérhvert $i \lt N$, og
	- $e_{N,j} = t_{N,j-1} + X \cdot (S[j]-S[j-1])$.
* Rúta $i$ kemur að röðunarstöð $j$ á *hæsta* af væntum komutímum rútu $i$ og rútum sem komu að röðunarstöð $j-1$ fyrr en rúta $i$. Formlega, látum $t_{i,j}$ vera hámarksgildi $e_{i,j}$ og $e_{k,j}$ þar sem $0 \le k \le N$ og $t_{k, j-1} \lt t_{i,j-1}$.

Skipuleggjendur IOI vilja ákvarða hvenær vararútan, sem er númer $N$, skal leggja af stað.
Verkefni þitt er að svara $Q$ fyrirspurnum frá skipuleggjendum sem eru á eftirfarandi formi: gefið tímann $Y$, í sekúndum, sem segir hvenær vararútan á að leggja af stað, á hvaða tíma myndi hún koma að hótelinu?

## Útfærsluatriði

Verkefnið þitt er að útfæra eftirfarandi föll.

```
void init(int L, int N, int64[] T, int[] W, int X, int M, int[] S)
```

* $L$: lengd vegarins.
* $N$: fjöldi rútna sem eru ekki vararútan
* $T$: fylki af stærð $N$ sem lýsir á hvaða tímum rúturnar sem eru ekki vararútan eiga að leggja af stað frá flugvellinum.
* $W$: fylki af stærð $N$ sem lýsir hámarkshraða rútnanna sem eru ekki vararútan.
* $X$: tíminn sem tekur fyrir vararútuna að ferðast $1$ kílómetra.
* $M$: fjöldi röðunarstöðva.
* $S$: fylki af stærð $M$ sem lýsir fjarlægð röðunarstöðvanna frá flugvellinum.
* Kallað er í þetta fall nákvæmlega einu sinni í hverju prufutilviki, áður en kallað er í `arrival_time`.

```
int64 arrival_time(int64 Y)
```

* $Y$: tíminn sem vararútan, sem er númer $N$, á að fara frá flugvellinum.
* Þetta fall skal skila út komutíma vararútunnar að hótelinu.
* Kallað er í þetta fall nákvæmlega $Q$ sinnum.

## Sýnidæmi

Íhugaðu eftirfarandi runu af fallaköllum.

```
init(6, 4, [20, 10, 40, 0], [5, 20, 20, 30], 10, 4, [0, 1, 3, 6])
```

Ef við hunsum rútu $4$ þar sem hún er vararúta, þá sýnir eftirfarandi tafla vænta komutíma og alvöru komutíma rútnanna sem eru ekki vararútan á sérhverri röðunarstöð:

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:---------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $55$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$

Komutímar á stöðina $0$ eru áætluðu tímar rútnanna til að leggja af stað frá flugvellinum.
Það er, $t_{i,0} = T[i]$ fyrir $0 \le i \le 4$.

Væntir komutímar og alvöru komutímar að röðunarstöðu $1$ eru reiknaðir á eftirfarandi hátt:
* Væntir komutímar á stöð $1$:
  - Rúta $0$: $e_{0,1} = t_{0,0} + W[0] \cdot (S[1]-S[0]) = 20 + 5 \cdot 1 = 25$.
  - Rúta $1$: $e_{1,1} = t_{1,0} + W[1] \cdot (S[1]-S[0]) = 10 + 20 \cdot 1 = 30$.
  - Rúta $2$: $e_{2,1} = t_{2,0} + W[2] \cdot (S[1]-S[0]) = 40 + 20 \cdot 1 = 60$.
  - Rúta $3$: $e_{3,1} = t_{3,0} + W[3] \cdot (S[1]-S[0]) = 0 + 30 \cdot 1 = 30$.
* Komutímar á stöð 1:
	- Rúta $1$ og rúta $3$ koma að stöð $0$ fyrr en rúta $0$, því er $t_{0,1} = \max([e_{0,1},e_{1,1},e_{3,1}]) = 30$.
	- Rúta $3$ kemur á stöð $0$ fyrr en rúta $1$, því er $t_{1,1} = \max([e_{1,1},e_{3,1}]) = 30$
	- Rúta $0$, rúta $1$ og rúta $3$ koma að stöð $0$ fyrr en rúta $2$, so $t_{2,1} = \max([e_{0,1},e_{1,1},e_{2,1},e_{3,1}]) = 60$.
	- Engin rúta kemur á stöð $0$ fyrr en rúta $3$, því er $t_{3,1} = \max([e_{3,1}]) = 30$.

```
arrival_time(0)
```

Rúta $4$ tekur $10$ sekúndur að ferðast $1$ kílómetra og á að fara frá flugvellinum á $0$-tu sekúndunni.
Í þessu tilfelli sýnir eftirfarandi taflan okkur komutíma hverrar rútu.
Eina breytingin við vænta og alvöru komutíma rútnanna sem eru ekki vararútan hefur verið undirstrikuð.

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:-----------------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $\underline{60}$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$
$4$ || $0$       || $10$      | $10$      || $30$      | $30$      || $60$      | $60$

Við sjáum að rúta $4$ kemur að hótelinu á sekúndu $60$.
Því skal fallið skila $60$.

```
arrival_time(50)
```

Rúta $4$ á núna að fara frá flugvellinum á sekúndu $50$.
Í þessu tilviki eru engar breytingar á komutímum fyrir rúturnar sem eru ekki vararútan.
Komutímarnir eru sýndir í eftirfarandi töflu.

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:---------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $55$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$
$4$ || $50$      || $60$      | $60$      || $80$      | $90$      || $120$     | $130$

Rúta $4$ tekur framúr hægari rútunni $2$ á röðunarstöð $1$ þar sem þær koma þangað á sama tíma.
Næst fylkjast rúta $4$ með rútu $3$ milli stöðvar $1$ og stöðvar $2$, sem verður til þess að rúta $4$ kemur að stöð $2$ á sekúndu $90$ í stað sekúndu $80$.
Eftir að hún fer frá stöð $2$ fylkjast rúta $4$ með rútu $1$ þar til þær koma að hótelinu.
Rúta $4$ kemur að hótelinu á sekúndu $130$.
Því skal fallið skila $130$.


Við getum teiknað graf af tímanum sem tekur fyrir sérhverja rútu að komast að sérhverri fjarlægð frá flugvellinum. 
Á grafinu táknar x-ásinn fjarlægðina frá flugvellinum í kílómetrum og y-ásinn táknar tímann sem hefur liðið í sekúndum.
Lóðréttar strikalínur tákna staðsetningar röðunarstöðvanna.
Mismunandi óbrotnar línur sem fylgja númerum rútnanna tákna fjórar rúturnar sem eru ekki vararútan.
Svarta punktalínan táknar vararútuna.


 `arrival_time(0)`               | `arrival_time(50)`
:-------------------------------:|:------------------------------:
![](overtaking-query1-new.png)   | ![](overtaking-query2-new.png)

## Skorður

* $1 \le L \le 10^9$
* $1 \le N \le 1\,000$
* $0 \le T[i] \le 10^{18}$, fyrir sérhvert $i$ þar sem $0 \le i \lt N$
* $1 \le W[i] \le 10^9$, fyrir sérhvert $i$ þar sem $0 \le i \lt N$
* $1 \le X \le 10^9$
* $2 \le M \le 1\,000$
* $0 = S[0] \lt S[1] \lt \cdots \lt S[M-1] = L$
* $1 \le Q \le 10^6$
* $0 \le Y \le  10^{18}$

## Hlutverkefni

1. (9 stig) $N = 1, Q \le 1\,000$
1. (10 stig) $M = 2, Q \le 1\,000$
1. (20 stig) $N, M, Q \le 100$
1. (26 stig) $Q \le 5\,000$
1. (35 stig) Engar frekari skorður.

## Sýnisyfirferðarforrit

Sýnisyfirferðarforritið les inntakið á eftirfarandi sniði:

* lína $1$: $L \; N \; X \; M \; Q$
* lína $2$: $T[0] \; T[1] \; \ldots \; T[N-1]$
* lína $3$: $W[0] \; W[1] \; \ldots \; W[N-1]$
* lína $4$: $S[0] \; S[1] \; \ldots \; S[M-1]$
* lína $5 + k$ ($0 \le k \lt Q$): $Y$ í fyrirspurn $k$


Sýnisyfirferðarforritði skrifar svörin þín á eftirfarandi sniði:

* lína $1 + k$ ($0 \le k \lt Q$): skilagildi `arrival_time` í fyrirspurn $k$
