# Overtaking

Будапешт әуежайынан Forrás қонақ үйіне дейін бір жолақты, бір жақты жол бар. Жолдың ұзындығы $L$ километр.

IOI 2023 іс-шарасы барысында $N+1$ трансфер автобустары осы жолмен жүреді. Автобустар $0$-дан $N$-ға дейін нөмірленген.
$i$ автобусы ($0 \le i \lt N$) әуежайдан $T[i]$-інші секундында шығуы керек және $1$ километрді $W[i]$ секундта жүре алады.
$N$ші автобус — $1$ километрді $X$ секундта жүріп өтетін резервтік автобус.
Оның әуежайдан шығатын $Y$ уақыты әлі анықталған жоқ.

Жалпы жолда басып озуға рұқсат етілмейді, бірақ **сұрыптау бекеттерінде** автобустардың бір-бірін басып озуына рұқсат етіледі.
Жолдың әртүрлі позицияларында $0$-дан $M - 1$-ға дейін нөмірленген $M$ ($M \gt 1$) сұрыптау станциялары бар.
$j$ сұрыптау станциясы ($0 \le j \lt M$) әуежайдан $S[j]$ километр қашықтықта жол бойында орналасқан.
Сұрыптау станциялары әуежайдан өсу қашықтығы бойынша сұрыпталады, яғни әрбір $0 \le j \le M - 2$ үшін $S[j] \lt S[j+1]$.
Бірінші сұрыптау станциясы – аэропорт, соңғысы – қонақ үй, яғни $S[0] = 0$ және $S[M-1] = L$.

Әрбір автобус жолда өзінен баяуырақ келе жатқан автобусты қуып жетпесе, максималды жылдамдықпен жүреді, ал қуып жетсе олар келесі сұрыптау станциясына жеткенше баяуырақ автобустың жылдамдығымен жүруге мәжбүр болады.
Онда жылдам автобустар баяу автобустарды басып озады.

Ресми түрде,  $0 \le i \le N$ және $0 \le j \lt M$ орындалатын әрбір $i$ және $j$ үшін $t_{i,j}$ (секундпен) $i$ші автобус  $j$ші сұрыптау станциясы **келетін уақыт**.
Әрбір $0 \le i \lt N$ үшін $t_{i,0} = T[i]$ болсын, ал $t_{N,0} = Y$ болсын.
Әрбір $j$ үшін $0 \lt j \lt M$:
* $i$ автобусының $j$ сұрыптауға келетін **күтілетін келу уақытын** (секундпен) $e_{i,j}$ деп $i$ автобустың $j-1$ сұрыптау станциясына келген уақыттан бастап толық жылдамдықпен жүретін болса, $j$ сұрыптау станциясына келетін уақытты анықтайық. Яғни, 
   - $e_{i,j} = t_{i,j-1} + W[i] \cdot (S[j]-S[j-1])$ әрбір $0 \le i \lt N$ үшін және
   - $e_{N,j} = t_{N,j-1} + X \cdot (S[j]-S[j-1])$.
* $i$ автобусы $j$ сұрыптау станциясына $j-1$ станциясына $i$ автобусынан ерте келген кез келген басқа автобустың күтілетін келу уақытының *максимумында* келеді. Ресми түрде $t_{i,j}$дің мәні $e_{i,j}$ және $e_{k,j}$ максимумы болады, кез келген $0 \le k \le N$ және $t_{k,j-1}  \lt t_{i,j-1}$ үшін .
 
IOI ұйымдастырушылары резервтік автобусты (автобус $N$) жоспарлағысы келеді.
Сіздің міндетіңіз - ұйымдастырушылардың келесі формадағы $Q$ сұрақтарына жауап беру: резервтік автобус әуежайдан шығуы тиіс болған $Y$ уақытын (секундтармен) ескере отырып, ол қонақүйге қай уақытта келеді?

## Implementation Details

Сізге келесі функцияны іске асыру қажет.

```
void init(int L, int N, int64[] T, int[] W, int X, int M, int[] S)
```

* $L$: жолдың ұзындығы.
* $N$: резервтік емес автобустардың саны.
* $T$: резервтік емес автобустардың әуежайдан жөнелтілетін уақыттарын сипаттайтын ұзындығы $N$ массив.
* $W$: резервтік емес автобустардың максималды жылдамдықтарын сипаттайтын ұзындығы $N$ массив.
* $X$: резервтік автобусқа $1$ километр жол жүруге кететін уақыт.
* $M$: сұрыптау станцияларының саны.
* $S$: сұрыптау станцияларының әуежайдан қашықтығын сипаттайтын ұзындығы $M$ массив.
* Бұл процедура әрбір сынақ жағдайы үшін, `arrival_time` деген кез келген шақырулардан бұрын дәл бір рет шақырылады.

```
int64 arrival_time(int64 Y)
```

* $Y$: резервтік автобус (автобус $N$) әуежайдан шығуы тиіс уақыт.
* Бұл процедура резервтік автобустың қонақүйге келетін уақытын қайтаруы керек.
* Бұл процедура дәл $Q$ рет деп шақырылады.
## Example

Келесі шақырулар тізбегін қарастырайық:

```
init(6, 4, [20, 10, 40, 0], [5, 20, 20, 30], 10, 4, [0, 1, 3, 6])
```

$4$ автобуссыз қарайық (ол әлі жоспарланбаған), келесі кестеде әрбір сұрыптау станциясында резервтік емес автобустардың күтілетін және нақты келу уақыты көрсетілген.

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:---------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $55$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$

$0$ станциясына келу уақыты - автобустардың әуежайдан шығатын уақыты. Яғни, $0 \le i \le 3$ үшін $t_{i,0} = T[i]$.

$1$ сұрыптау станциясына күтілетін және нақты келу уақыты келесідей есептеледі:
* $1$ станциясына күтілетін келу уақыты:
   - $0$ автобусы: $e_{0,1} = t_{0,0} + W[0] \cdot (S[1]-S[0]) = 20 + 5 \cdot 1 = 25$.
   - $1$ автобусы: $e_{1,1} = t_{1,0} + W[1] \cdot (S[1]-S[0]) = 10 + 20 \cdot 1 = 30$.
   - $2 $ автобусы: $e_{2,1} = t_{2,0} + W[2] \cdot (S[1]-S[0]) = 40 + 20 \cdot 1 = 60$.
   - $3$ автобусы: $e_{3,1} = t_{3,0} + W[3] \cdot (S[1]-S[0]) = 0 + 30 \cdot 1 = 30$.
* $1$ станциясына келу уақыты:
   - $1$ және $3$ автобустары $0$ станцияға $0$ автобусынан ерте келеді, сондықтан $t_{0,1} = \max([e_{0,1},e_{1,1},e_{3,1 }]) = 30$.
   - $3$ автобус $0$ станцияға $1$ автобусынан ерте келеді, сондықтан $t_{1,1} = \max([e_{1,1},e_{3,1}]) = 30$.
   - $0$ автобус, $1$ автобус және $3$ автобус $0$ сұрыптау станциясына $2$ автобусынан  ерте келеді, сондықтан $t_{2,1} = \max([e_{0,1},e_{1,1} ,e_{2,1},e_{3,1}]) = 60$.
   - Ешбір автобус $0$ станцияға $3$ автобусынан ерте келмейді, сондықтан $t_{3,1} = \max([e_{3,1}]) = 30$.
```
arrival_time(0)
```
$4$ші автобус $1$ километр жол жүру үшін $10$ секунд кетіреді және әуежайдан $0$-ші секундта шығады деп жоспарланған.
Бұл жағдайда келесі кестеде әрбір автобустың келу уақыттары көрсетілген.
Резервтік емес автобустардың күтілетін және нақты келу уақытына қатысты жалғыз өзгерістің асты сызылған.


$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:-----------------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $\underline{60}$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$
$4$ || $0$       || $10$      | $10$      || $30$      | $30$      || $60$      | $60$

Біз $4$ тұратын автобус қонақүйге $60$-шы секундта келгенін көреміз.
Осылайша, функция $60$ қайтаруы керек.
```
arrival_time(50)
```

$4$-ші автобус енді әуежайдан $50$-шы секундта шығады деп жоспарланған.
Бұл ретте бастапқы кестемен салыстырғанда резервтік емес автобустардың келу уақытында ешқандай өзгерістер жоқ.
Келу уақыты келесі кестеде көрсетілген.

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:---------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $55$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$
$4$ || $50$      || $60$      | $60$      || $80$      | $90$      || $120$     | $130$

$4$ автобус $1$ сұрыптау станциясына келгенде баяуырақ $2$ автобусты басып озады.
Әрі қарай, $4$ автобус $1$ станциясы мен $2$ станциясы арасында $3$ автобусына қуып жетіп, $4$ автобус $2$ станцияға  $80$-ның орнына $90$-шы секундта жетеді.
$2$ станциядан шыққаннан кейін,$4$ автобус қонақүйге жеткенше $1$ автобусқа жетеді.
Солай $4$ автобус қонақүйге $130$-шы секундта келеді.
Осылайша, функция $130$ қайтаруы керек.

Біз әрбір автобустың әуежайдан әр қашықтыққа жету уақытын белгілей аламыз.
Сюжеттің x осі әуежайға дейінгі қашықтықты (километрмен) және учаскенің у осі уақытты (секундтармен) көрсетеді.
Тік үзік сызықтар сұрыптау станцияларының орындарын белгілейді.
Әртүрлі тұтас сызықтар (шиналар индекстерімен бірге) төрт резервтік емес автобусты білдіреді.
Нүктелі қара сызық резервтік автобусты білдіреді.

 `arrival_time(0)`               | `arrival_time(50)`
:-------------------------------:|:------------------------------:
![](overtaking-query1-new.png)   | ![](overtaking-query2-new.png)

## Constraints

* $1 \le L \le 10^9$
* $1 \le N \le 1\,000$
* $0 \le T[i] \le 10^{18}$ ( $0 \le i \lt N$ болатын кез келген $i$ үшін)
* $1 \le W[i] \le 10^9$ ( $0 \le i \lt N$ болатын кез келген $i$ үшін)
* $1 \le X \le 10^9$
* $2 \le M \le 1\,000$
* $0 = S[0] \lt S[1] \lt \cdots \lt S[M-1] = L$
* $1 \le Q \le 10^6$
* $0 \le Y \le  10^{18}$

## Subtasks

1. (9 ұпай) $N = 1, Q \le 1\,000$
1. (10 ұпай) $M = 2, Q \le 1\,000$
1. (20 ұпай) $N, M, Q \le 100$
1. (26 ұпай) $Q \le 5\,000$
1. (35 ұпай) Қосымша шектеулер жоқ..

## Sample Grader

Үлгі грейдер енгізуді келесі форматта оқиды::

* line $1$: $L \; N \; X \; M \; Q$
* line $2$: $T[0] \; T[1] \; \ldots \; T[N-1]$
* line $3$: $W[0] \; W[1] \; \ldots \; W[N-1]$
* line $4$: $S[0] \; S[1] \; \ldots \; S[M-1]$
* line $5 + k$ ($0 \le k \lt Q$): $Y$ сұрақ $k$ үшін

Үлгі грейдер жауаптарыңызды келесі форматта шығарады::

* line $1 + k$ ($0 \le k \lt Q$):  $k$ сұрақ үшін `arrival_time` уақыты 