# Ашып өтүш

Будапешт аэропортунан Форраш мейманканасына чейин бир тилкелүү, бир тараптуу жол бар. Жолдун узундугу $L$ километрди түзөт.

IOI 2023 иш-чарасында $N+1$ трансфер автобустары бул жолдон өтүшөт. Автобустар $0$дөн $N$ге чейин номерленген.
$i$ автобусу ($0 \le i \lt N$) аэропорттон $T[i]$-секундунда жөнөйт жана $1$ километрди $W[i]$ секундада басып өтөт.
$N$ —  автобус $1$ километрди $X$ секундда басып өтө турган резервдик автобус.
Анын аэропорттон качан чыга турган $Y$ убактысы азырынча чечиле элек.

Жолдо жалпы ашып өтүүгө жол берилбейт, бирок автобустар **ашып өтүүчү пункттарда** бири-биринен ашып өтүүгө уруксат берилет.
Жолдун ар кандай позицияларында $0$дөн $M - 1$ге чейин номерленген $M$ ($M \gt 1$) ашып өтүүчү пункттар бар.
Ашып өтүүчү пункттар $j$ ($0 \le j \lt M$) аэропорттон $S[j]$ километр алыстыкта, жол боюнда жайгашкан.
Ашып өтүүчү пункттарар аэропорттон өсүү аралыкта сорттолгон, башкача айтканда, ар бир $0 \le j \le M - 2$ үчүн $S[j] \lt S[j+1]$.
Биринчи ашып өтүүчү пункт аэропорт, акыркысы мейманкана, башкача айтканда, $S[0] = 0$ жана $S[M-1] = L$.

Ар бир автобус жолдон алдыда бара жаткан жайыраак автобуска жетип калбаса, максималдуу ылдамдыкта жүрөт, бул учурда алар топтолуп, кийинки ашып өтүүчү пунктка жеткенге чейин жайыраак автобустун ылдамдыгы менен жүрүүгө аргасыз болушат.
Ал жерде ылдамыраак автобустар жайыраак автобустарды ашып өтүшөт.

Формалдуу түрдө ар бир $i$ жана $j$ үчүн $0 \le i \le N$ жана $0 \le j \lt M$, $t_{i,j}$ (секунд менен) $i$  - автобус $j$ - ашып өтүүчү пунктка **келиши**   төмөнкүдөй аныкталат.
Ар бир $0 \le i \lt N$ үчүн $t_{i,0} = T[i]$ болсун жана $t_{N,0} = Y$ болсун.
Ар бир $j$ үчүн $0 \lt j \lt M$:
* $i$ автобусунун $j$ ашып өтүүчү пункттуна **күтүлгөн келүү убактысын** (секунд менен) аныктаңыз, $e_{i,j}$ менен белгиленет, $i$ автобусу ашып өтүүчү пунктка келе турган убакыт катары $j$ - ашып өтүүчү пунктка, эгерде ал ашып өтүүчү пунктка $j-1$ келген учурдан тартып толук ылдамдыкта жүрсө. Башкача айтканда, болсун
   - $e_{i,j} = t_{i,j-1} + W[i] \cdot (S[j]-S[j-1])$ ар бир $0 \le i \lt N$ үчүн, жана
   - $e_{N,j} = t_{N,j-1} + X \cdot (S[j]-S[j-1])$.
* $i$ автобусу $j$ ашып өтүүчү пунктуна $i$ автобусунун жана $i$ автобусунан $j-1$ ашып өтүүчү пунктуна эрте келген ар бир башка автобустун күтүлгөн келүү убактысынын *максимумуна* келет. Формалдуу түрдө $t_{i,j}$ максимум $e_{i,j}$ жана ар бир $e_{k,j}$ болсун, алар үчүн $0 \le k \le N$ жана $t_{k,j -1} \lt t_{i,j-1}$.

IOI уюштуруучулары резервдик автобустун (автобус $N$) графигин түзүүнү каалашат.
Сиздин милдет - уюштуруучулардын төмөнкүдөй формадагы $Q$ суроолоруна жооп берүү: резервдик автобус аэропорттон качан чыгышы керек болгон $Y$ убактысын (секунд менен) эске алганда, ал мейманканага саат канчада келет ?


## Ишке ашыруу деталдары

Сиз төмөнкү процедураны ишке ашырууңуз керек.

```
void init(int L, int N, int64[] T, int[] W, int X, int M, int[] S)
```

* $L$: жолдун узундугу.
* $N$: резервдик эмес автобустардын саны.
* $T$: узундуктагы $N$ массивинде резервдик эмес автобустардын аэропорттон жөнөй турган убактысы.
* $W$: резервдик эмес автобустардын максималдуу ылдамдыгы $N$ узундуктагы массив.
* $X$: резервдик автобустун $1$ километр жол жүрүү убактысы.
* $M$: ашып өтүүчү пункттардын саны.
* $S$: ашып өтүүчү пункттардын аэропорттон алыстыгын сүрөттөгөн $M$ узундуктагы массив.
* Бул процедура ар бир тест учуру үчүн, `arrival_time` чакыруулардан мурун так бир жолу чакырылат.

```
int64 arrival_time(int64 Y)
```

* $Y$: резервдик автобус (автобус $N$) аэропорттон кете турган убакыт.
* Бул процедура резервдик автобус мейманканага келе турган убакытты кайтарып бериши керек.
* Бул процедура так $Q$ жолу чакырылат.

## Мисал

Чакыруулардын төмөнкү ырааттуулугун карап көрөйлү:


```
init(6, 4, [20, 10, 40, 0], [5, 20, 20, 30], 10, 4, [0, 1, 3, 6])
```

$4$ автобуска көңүл бурбай (ал азырынча пландала элек), төмөнкү таблицада ар бир ашып өтүүчү пунктка резервдик эмес автобустар үчүн күтүлгөн жана иш жүзүндөгү келүү убакыттары көрсөтүлгөн:

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:---------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $55$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$

$0$ пунктуна келүү убактысы - бул автобустардын аэропорттон чыга турган убактары. Башкача айтканда, $0 \le i \le 3$ үчүн $t_{i,0} = T[i]$.

$1$ - ашып өтүүчү пунктка келүүлөрдүн күтүлгөн жана иш жүзүндөгү убакыттары төмөнкүчө эсептелет:

* $1$ ашып өтүүчү пунктка келүүнүн күтүлгөн убакыттары:

  - $0$ - автобус: $e_{0,1} = t_{0,0} + W[0] \cdot (S[1]-S[0]) = 20 + 5 \cdot 1 = 25$.
  - $1$  - автобус: $e_{1,1} = t_{1,0} + W[1] \cdot (S[1]-S[0]) = 10 + 20 \cdot 1 = 30$.
  - $2$ - автобус: $e_{2,1} = t_{2,0} + W[2] \cdot (S[1]-S[0]) = 40 + 20 \cdot 1 = 60$.
  - $3$  - автобус: $e_{3,1} = t_{3,0} + W[3] \cdot (S[1]-S[0]) = 0 + 30 \cdot 1 = 30$.
 


* $1$ ашып өтүүчү пунктка иш жүзүндө келген убакыттары:
   - $1$ -   жана $3$ -  автобустары $0$ - ашып өтүүчү пунктка $0$ -  автобуска караганда  эрте келет, андыктан $t_{0,1} = \max([e_{0,1},e_{1,1},e_{3,1 }]) = 30$.
   - $3$  - автобус $0$ - ашып өтүүчү пунктка $1$ - автобуска караганда эрте келет, андыктан $t_{1,1} = \max([e_{1,1},e_{3,1}]) = 30$.
   - $0$ , $1$ - жана $3$ - автобус $0$ - ашып өтүүчү пунктка $2$ - автобуска караганда  эрте келет, ошондуктан $t_{2,1} = \max([e_{0,1},e_{1,1} ,e_{2,1},e_{3,1}]) = 60$.
   - Бир дагы автобус $0$ - ашып өтүүчү пунктка $3$ - автобуска караганда эрте келбейт, андыктан $t_{3,1} = \max([e_{3,1}]) = 30$.
 
```
arrival_time(0)
```

$4$ - автобус $1$ километрди басып өтүү үчүн $10$ секунд талап кылынат жана азыр аэропорттон $0$-секундада жөнөйт.
Бул учурда төмөнкү таблицада ар бир автобустун келүү убактысы көрсөтүлгөн.
Резервдик эмес автобустардын күтүлгөн жана иш жүзүндөгү келүү убактысына байланыштуу бир гана өзгөрүү баса белгиленген.


$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:-----------------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $\underline{60}$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$
$4$ || $0$       || $10$      | $10$      || $30$      | $30$      || $60$      | $60$

$4$ -  автобус мейманканага $60$-секунда келгенин көрүп жатабыз.
Ошондуктан, процедура $60 $ кайтарып бериши керек.



```
arrival_time(50)
```

Эми $4$-автобус аэропорттон $50$-секундда жөнөйт.
Мында баштапкы таблицага салыштырганда резервдик  эмес автобустардын келуу убактысында эч кандай өзгөрүүлөр жок.
Келүү убактысы төмөнкү таблицада көрсөтүлгөн.


$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:---------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $55$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$
$4$ || $50$      || $60$      | $60$      || $80$      | $90$      || $120$     | $130$

$4$ - автобус жайыраак болгон $2$ - автобус менен бир убакта келгет жана $1$ - ашып өтүүчү пункта ашып кетет.
Андан кийин, $4$-автобус $1$-ашып өтүүчү пункт менен $2$-ашып өтүүчү пунктун ортосунда $3$-автобус менен бирге, $4$-автобус $2$-ашып өтүүчү пунктка $80$-секунда эмес, $90$-секундада келет.
$2$-станциядан чыккандан кийин $4$-автобус мейманканага жеткенге чейин $1$-автобуска толуп калат.
$4$-автобус мейманканага $130$ секундда келет.
Ошентип, процедура $130$ кайтарылышы керек.

Биз аэропорттон ар бир аралыкта ар бир автобустун келүү убактысын түзө алабыз.
Сюжеттин x огу аэропорттон отелге чейинки аралыкты (километр менен) жана участоктун у огу убакытты (секунд менен) көрсөтөт.
Тик сызыктар ашып өтүүчү пунктардын позицияларын белгилейт.
Ар кандай катуу сызыктар (автобус индекстери менен коштолгон) төрт резервдик эмес автобустарды билдирет.
Чекиттүү кара сызык резервдик автобусту билдирет.


 `arrival_time(0)`               | `arrival_time(50)`
:-------------------------------:|:------------------------------:
![](overtaking-query1-new.png)   | ![](overtaking-query2-new.png)

## Чектөөлөр

* $1 \le L \le 10^9$
* $1 \le N \le 1\,000$
* $0 \le T[i] \le 10^{18}$ (ар бир $i$ үчүн $0 \le i \lt N$)
* $1 \le W[i] \le 10^9$ (ар бир $i$ үчүн $0 \le i \lt N$)
* $1 \le X \le 10^9$
* $2 \le M \le 1\,000$
* $0 = S[0] \lt S[1] \lt \cdots \lt S[M-1] = L$
* $1 \le Q \le 10^6$
* $0 \le Y \le  10^{18}$

## Кошумча тапшырмалар

1. (9 упай) $N = 1, Q \le 1\,000$
1. (10 упай) $M = 2, Q \le 1\,000$
1. (20 упай) $N, M, Q \le 100$
1. (26 упай) $Q \le 5\,000$
1. (35 упай) Кошумча чектөө жок.

## Үлгү Грейдер

Үлгү грейдер киргизүүнү төмөнкү форматта окуйт:

* $1$ - сап: $L \; N \; X \; M \; Q$
* $2$ - сап: $T[0] \; T[1] \; \ldots \; T[N-1]$
* $3$ - сап: $W[0] \; W[1] \; \ldots \; W[N-1]$
* $4$ - сап: $S[0] \; S[1] \; \ldots \; S[M-1]$
* $(5 + k)$ - сап ($0 \le k \lt Q$): $k$ - суроо үчүн $Y$  

Үлгү грейдер жообуңузду төмөнкү форматта басып чыгарат:

* $(1 + k)$ - сап ($0 \le k \lt Q$): $k$ - суроосу үчүн `arrival_time`  кайтарылган мааниси
