# Гүйцэж түрүүлэх

Будапештийн нисэх онгоцны буудлаас Forrás зочид буудал хүртэл нэг урсгалтай, нэг чиглэлтэй замтай. Замын урт $L$ километр.

IOI 2023 арга хэмжээний үеэр тээвэрлэлтийн $N+1$ автобус энэ замаар явжээ. Автобуснуудыг $0$-оос $N$ хүртэл дугаарлана. $i$ ($0 \le i \lt N$) автобус нь $T[i]$ дэх секундэд нисэх буудлаас хөдлөх ба $1$ километр замыг  $W[i]$ секундэд туулна.

$N$ автобус нь $1$ километрийг $X$ секундэд туулах нөөц автобус юм. Онгоцны буудлаас хэзээ гарах хугацаа $Y$ нь хараахан тодорхой болоогүй байгаа.

Зам дээр гүйцэж түрүүлэхийг ерөнхийд нь хориглодог боловч автобуснуудыг **sorting station** дээр бие биеэ гүйцэж түрүүлэхийг зөвшөөрдөг. Уг замд $0$ -оос $M - 1$ хүртэл дугаарлагдсан ялгаатай байрлал бүхий $M$ ($M\gt1$) sorting station байдаг. $j$ ($0 \le j \lt M$) sorting station нь онгоцны буудлаас $S[j]$ километрийн зайд уг зам дагуу байрладаг. Sorting station нь онгоц буудлаас өсөхөөр эрэмбэлэгдсэн зайтай байгаа ба энэ нь ($0 \le j \le M - 2$) үед $S[j] \lt S[j+1]$ байна гэсэн үг. Хамгийн эхний sorting station нь онгоц буудал, хамгийн сүүлийнх нь зочид буудал байх ба $S[0] = 0$, $S[M-1] = L$ байх юм. 

Автобус бүр дээд хурдаараа явах ба урдаа яваа удаан автобусыг гүйцэж түрүүлэхгүй бол дараагийн sorting station хүртэл удаан автобусны хурдаар явахаас өөр аргагүй болдог. Илүү хурдтай яваа автобуснууд удаан яваа автобуснуудыг гүйцэж түрүүлнэ.

$0 \le i \le N$ ба $0 \le j \lt M$ байх $i$ болон $j$ бүрийн хувьд $i$  автобус $j$ sorting station **-д ирэх** нь $t_{i,j}$ (секундээр) нь дараах байдлаар тодорхойлогдоно. $0 \le i \lt N$ тус бүрд $t_{i,0} = T[i]$ ба $t_{N,0} = Y$ байг.
$0 \lt j \lt M$ байхаар $j$ бүрийн хувьд:
* $i$ автобус нь $j-1$ ангилах станцад ирсэн цагаасаа хойш бүрэн хурдтай явж байсан бол $i$ автобусны $j$ sorting station дээр $e_{i,j}$ гэж тэмдэглэсэн **хүлээгдэж буй ирэх цаг**-ийг (секундээр) тодорхойлно. Энэ нь:
   - $0 \le i \lt N$ бүрийн хувьд $e_{i,j} = t_{i,j-1} + W[i] \cdot (S[j]-S[j-1])$ ба
   - $e_{N,j} = t_{N,j-1} + X \cdot (S[j]-S[j-1])$ байна.
* $i$ автобус $j$ буудалд $i$ автобуснаас өмнө $j-1$ буудалд ирсэн автобус бүрийн хүлээгдэж буй *хамгийн их* хугацаанд $j$ sorting station дээр ирдэг. 
Тодруулбал, $e_{i,j}$ ба $0 \le k \le N$ ба $t_{k,j-1} \lt t_{i,j-1}$ байх $e_{k,j}$ бүрийн хамгийн их нь $t_{i,j}$ байх юм.

IOI-ийн зохион байгуулагчид нөөц автобусыг (Автобус $N$) явуулах хуваарийг тодорхойлохыг хүсч байна.
Таны даалгавар бол зохион байгуулагчдын $Q$ асуултуудад хариулах явдал бөгөөд эдгээр нь дараах хэлбэртэй байна: Нөөц автобус нисэх онгоцны буудлаас хөдлөх $Y$ цагийг (секундээр) өгвөл зочид буудалд хэдэн цагт ирэх вэ?

## Хэрэгжүүлэлт

Та дараах процедурыг бичиж хэрэгжүүлнэ.

```
void init(int L, int N, int64[] T, int[] W, int X, int M, int[] S)
```

* $L$: замын урт.
* $N$: Нөөц биш автобусны тоо
* $T$: Онгоц буудлаас явах нөөц биш автобуснуудын хөдлөх хугацааг хадгалсан $N$ урттай массив
* $W$: Нөөц биш автобуснуудын дээд хурдыг хадгалсан $N$ урттай массив.
* $X$: Нөөц автобусны $1$ километрийг туулах хугацаа
* $M$: Sorting station-нуудын тоо.
* $S$: Онгоц буудлаас sorting station-ууд хүртэлх зайг хадгалсан $M$ урттай массив
* Энэ процедурыг `arrival_time` дуудалт бүрийн өмнө тестийн тохиолдол бүрд яг нэг удаа дуудна. 

```
int64 arrival_time(int64 Y)
```

* $Y$: Нөөц автобус (автобус $N$) нисэх онгоцны буудлаас хөдлөх ёстой цаг.
* Энэ процедур нь нөөц автобусыг зочид буудалд ирэх цагийг буцаах ёстой.
* Энэ процедур яг $Q$ удаа дуудагдана.

## Жишээ

Дараах дуудалтыг хийсэн гэе:

```
init(6, 4, [20, 10, 40, 0], [5, 20, 20, 30], 10, 4, [0, 1, 3, 6])
```

$4$-р автобусыг (хуваарь нь хараахан гараагүй байгаа) үл тоомсорлож, дараах хүснэгтэд sorting station бүрт нөөц бус автобуснуудын ирэх хүлээгдэж буй болон бодит цагийг харуулав.

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:---------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $55$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$

Station $0$ дээр ирэх хугацаа нь онгоц буудлаас автобус бүрийн явахаар төлөвлөгдсөн хугацаа юм. Энд нь $t_{i,0} =T[i]$, $0 \le i \le 3$ байна.

 Sorting station $1$ дээр ирэх хүлээгдэж буй болон бодит хугацааг дараах байдлаар тооцоолно:
* Sorting station $1$ дээр ирэх хүлээгдэж буй болон бодит хугацаа:
  - Автобус $0$: $e_{0,1} = t_{0,0} + W[0] \cdot (S[1]-S[0]) = 20 + 5 \cdot 1 = 25$.
  - Автобус $1$: $e_{1,1} = t_{1,0} + W[1] \cdot (S[1]-S[0]) = 10 + 20 \cdot 1 = 30$.
  - Автобус $2$: $e_{2,1} = t_{2,0} + W[2] \cdot (S[1]-S[0]) = 40 + 20 \cdot 1 = 60$.
  - Автобус $3$: $e_{3,1} = t_{3,0} + W[3] \cdot (S[1]-S[0]) = 0 + 30 \cdot 1 = 30$.
*  Sorting station $1$ ирсэн хугацаа:
- $1$ ба $3$-р автобус $0$-р sorting station дээр $0$-р автобуснаас түрүүлж ирэх тул $t_{0,1} = \max([e_{0,1},e_{1,1},e_{3,1}]) = 30$.
  - $3$-р автобус $0$-р sorting station дээр $1$-р автобуснаас түрүүлж ирэх тул $t_{1,1} = \max([e_{1,1},e_{3,1}]) = 30$.
  - $0$, $1$, $3$-р автобуснууд $0$-р sorting station дээр $2$-р автобуснаас түрүүлж ирэх тул $t_{2,1} = \max([e_{0,1},e_{1,1},e_{2,1},e_{3,1}]) = 60$.
  - $3$-р автобуснаас өмнө $0$-р sorting station дээр ямар ч автобус ирэхгүй тул $t_{3,1} = \max([e_{3,1}]) = 30$


```
arrival_time(0)
```

$4$-р автобус $1$ километр явахад $10$ секунд зарцуулдаг бөгөөд яг одоо нисэх онгоцны буудлаас $0$ дахь секундэд хөдлөхөөр төлөвлөгдсөн. Энэ тохиолдолд автобус бүрийн ирэх цагийг дараах хүснэгтэд үзүүлэв. Нөөц бус автобусны хүлээгдэж буй болон бодит ирэх цагтай холбоотой цорын ганц өөрчлөлтийг онцлон тэмдэглэв. 

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:-----------------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $\underline{60}$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$
$4$ || $0$       || $10$      | $10$      || $30$      | $30$      || $60$      | $60$

Бид $4$-р автобусыг зочид буудал $60$ дахь секундэд ирэхийг харж байна. Энэ процедур $60$ гэсэн утгыг буцаана.

```
arrival_time(50)
```

$4$-р яг одоо автобус онгоц буудлаас $50$ дахь секундэд хөдлөхөөр төлөвлөгдсөн.
Энэ тохиолдолд эхний хүснэгттэй харьцуулахад нөөцийн бус автобуснуудын ирэх цаг өөрчлөгдөхгүй. Ирэх цагийг дараах хүснэгтэд үзүүлэв.

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:---------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $55$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$
$4$ || $50$      || $60$      | $60$      || $80$      | $90$      || $120$     | $130$

$4$-р автобус $1$-р sorting station дээр өөрөөсөө удаан яваа $2$-р автобусыг гүйцэж түрүүлнэ. Дараа нь $1$-ээс sorting station $2$ -ы хооронд $4$-р автобус $3$-р автобустай зэрэгцснээр $4$-р автобус $2$-р Sorting station-д $80$ дахь секунд биш $90$ дэх секундэд ирнэ. $2$-р sorting station-ээс гарсны дараа $4$-р автобус $1$-р автобустай зэрэгцэн зочид буудалд очно. $4$-р автобус $130$ дахь секундэд зочид буудалд ирсэн. Тиймээс процедур нь $130$-ыг буцаах ёстой

Бид  автобус тус бүрийн нисэх онгоцны буудлаас туулах зай бүрд зарцуулах хугацааг тооцоолж чадна. Графикийн x тэнхлэг нь нисэх онгоцны буудлаас хүрэх зайг (километрээр), y тэнхлэг нь хугацааг (секундээр) илэрхийлнэ.
Босоо тасархай шугамуудаар sorting stations-уудын байрлалыг тэмдэглэв.
Өнгө бүхий шугамууд нь (автобусны дугаарыг төлөөлөх) хуваарь бүхий нөөцийн биш дөрвөн автобусыг төлөөлдөг. Тасархай шугам нь нөөц автобусыг илэрхийлнэ.

 `arrival_time(0)`           | `arrival_time(50)`
:---------------------------:|:---------------------------:
![](overtaking-query1-new.png)   | ![](overtaking-query2-new.png)

## Хязгаарлалтууд

* $1 \le L \le 10^9$
* $1 \le N \le 1\,000$
* $0 \le T[i] \le 10^{18}$ ($0 \le i \lt N$ байх $i$ бүрийн хувьд)
* $1 \le W[i] \le 10^9$ ($0 \le i \lt N$ байх $i$ бүрийн хувьд )
* $1 \le X \le 10^9$
* $2 \le M \le 1\,000$
* $0 = S[0] \lt S[1] \lt \cdots \lt S[M-1] = L$
* $1 \le Q \le 10^6$
* $0 \le Y \le  10^{18}$

## Дэд бодлогууд

1. (9 оноо) $N = 1, Q \le 1\,000$
1. (10 оноо) $M = 2, Q \le 1\,000$
1. (20 оноо) $N, M, Q \le 100$
1. (26 оноо) $Q \le 5\,000$
1. (35 оноо) Нэмэлт хязгаарлалт байхгүй.

## Жишээ грейдер

Жишээ грейдер нь дараах форматын дагуу оролтыг уншина:
* мөр $1$: $L \; N \; X \; M \; Q$
* мөр $2$: $T[0] \; T[1] \; \ldots \; T[N-1]$
* мөр $3$: $W[0] \; W[1] \; \ldots \; W[N-1]$
* мөр $4$: $S[0] \; S[1] \; \ldots \; S[M-1]$
* мөр $5 + k$ ($0 \le k \lt Q$): $k$ асуулт бүрийн $Y$ 

Жишээ грейдер нь гаралтыг дараах форматын дагуу хэвлэнэ:

* мөр $1 + k$ ($0 \le k \lt Q$): $k$ асуултын `arrival_time` утгыг буцаана.
