# التجاوز

يوجد طريق باتجاه واحد وفي حارة واحدة فقط من مطار بودابست إلى فندق فوراش
طول هذا الطريق هو $L$ كيلومتر

خلال الأولمبياد الدولي الحالي ينتقل عدد من الباصات عددها $N+1$ على هذا الطريق
هذه الباصات مرقمة من $0$ وحتى $N$.
تم جدولة الباص رقم 
 $i$ ($0 \le i \lt N$) 
ليغادر المطار في الثانية 
$T[i]$ 
من الحدث، ويمكن لهذا الباص أن يقطع $1$ كيلومتر خلال 
$W[i]$ 
ثانية.
الباص رقم 
$N$ 
هو باص احتياطي يمكنه أن يقطع $1$ كيلومتر خلال $X$ ثانية أما وقت مقادرته المطار وهو $Y$ فهو غير محدد بعد.

من غير المسموح التجاوز على هذا الطريق بشكل عام ولكن يمكن للباصات أن تتجاوز بعضها في **محطات الترتيب**.
يوجد 
 $M$ ($M \gt 1$) 
محطة ترتيب، مرقمة من $0$ وحتى $M-1$ ، وموجودة في أماكن مختلفة على الطريق
محطة الترتيب رقم 
 $j$ ($0 \le j \lt M$) 
موجودة على بعد
 $S[j]$ 
كيلومتر من المطار على طول الطريق، محطات الترتيب مرتبة تصاعدياً بحسب المسافة من المطار أي أن 
, $S[j] \lt S[j+1]$ من أجل كل $0 \le j \le M - 2$.
محطة الترتيب الأولى هي المطار ومحطة الترتيب الأخيرة هي الفندق أي أنه:
 $S[0] = 0$ و $S[M-1] = L$.

يسافر كل باص بالسرعة القصوى الخاصة به إلا إذا تمكن من اللحاق بباص أبطأ منه كان يسافر قبله على الطريق، في هذه الحالة وبما أنه لا يستطيع تجاوزه سيسير الباصان مع بعضهما مضطرين للسير معاً بسرعة الباص الأبطأ، حتى يصلوا إلى محطة الترتيب التالية، وهناك الباص الأسرع يمكنه تجاوز الباص الأبطأ والمتابعة بسرعته القصوى.

بشكل رياضي من أجل كل 
 $i$ و $j$ بحيث $0 \le i \le N$ و $0 \le j 
\lt M$, الوقت $t_{i,j}$ (بالثواني) الذي سوف  **يصل به الباص $i$** 
إلى محطة الترتيب $j$ معرف كالتالي.
ليكن $t_{i,0} = T[i]$ من أجل كل $0 \le i \lt N$, وليكن $t_{N,0} = Y$.
من أجل أي $j$ بحيث $0 \lt j \lt M$:
* لنعرف **الوقت المتوقع للوصول** (بالثواني) للباص 
 $i$ إلى محطة الترتيب $j$, والمرمزة بالرمز $e_{i,j}$, بأنه الوقت المتوقع لوصول الباص $i$ 
إلى محطة الترتيب $j$ فيما لو كان يسير بالسرعة القصوى الخاصة به من محطة الترتيب 
 $j-1$. 
ذلك يعني أنه: ليكن 

  - $e_{i,j} = t_{i,j-1} + W[i] \cdot (S[j]-S[j-1])$ من أجل كل $0 \le i 
\lt N$, و
  - $e_{N,j} = t_{N,j-1} + X \cdot (S[j]-S[j-1])$.
* الباص $i$ يصل إلى محطة الترتيب $j$ بالقيمة *الأكبر* بين الوقت المتوقع للوصول للباص $i$ وأي باص أخر وصل إلى المحطة $j-1$ أبكر من الوقت $i$. بشكل رياضي يكون $t_{i,j}$ 
هو القيمة العظمى بين $e_{i,j}$ وبين كل $e_{k,j}$ بحيث $0 \le k \le 
N$ و $t_{k,j-1} \lt t_{i,j-1}$.

يريد منظمو الأولمبياد جدولة وقت الباص الاحتياطي (الباص رقم $N$). مهمتك هي الإجابة عن $Q$ سؤالاً من المنظمين، وهي من الشكل التالي: بعد إعطائك الوقت $Y$ (بالثواني) وهو الوقت الذي من المفترض أن يغادر فيه الباص الاحتياطي المطار، ما هو الوقت الذي يمكن لهذا الباص أن يصل به إلى الفندق.


## تفاصيل البرمجة

مهمتك هي برمجة الإجرائيتين التاليتين.

```
void init(int L, int N, int64[] T, int[] W, int X, int M, int[] S)
```

* $L$: طول الطريق.
* $N$: عدد الباصات (من دون الباص الاحتياط).
* $T$: مصفوفة طولها $N$ تحدد الأوقات التي يجب على الباصات (غير الاحتياطية) أن تغادر فيها المطار.
* $W$: مصفوفة طولها $N$ تحدد السرعات العظمى للباصات غير الاحتياطية.
* $X$: الوقت الذي يلزم الباص الاحتياطي ليقطع مسافة  $1$ كيلومتر.
* $M$: عدد محطات الترتيب.
* $S$: مصفوفة طولها $M$ تحدد مسافات محطات الترتيب عن المطار.
* سيتم استدعاء هذه الإجرائية مرة واحدة تماماً من أجل كل حالة اختبار وذلك قبل أي استدعاء للإجرائية
 `arrival_time`.

```
int64 arrival_time(int64 Y)
```


* $Y$: الوقت الذي سيغادر فيه الباص الاحتياطي (الباص رقم $N$) من المطار .
* يجب أن تعيد هذه الإجرائية الوقت الذي سيصل فيه الباص الاحتياطي إلى الفندق.
* سيتم استدعاء هذه الإجرائية $Q$ مرة تماماً 

## مثال

ليكن لدينا التسلسل التالي من الاستدعاءات:

```
init(6, 4, [20, 10, 40, 0], [5, 20, 20, 30], 10, 4, [0, 1, 3, 6])
```

بإهمال الباص رقم 4 والذي لم تتم جدولته بعد يوضح الجدول التالي أوقات الوصول المتوقعة والحقيقية للباصات غير الاحتياطية في كل محطة ترتيب:

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:---------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $55$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$

الأوقات المتوقعة والحقيقية للوصول إلى محطة الترتيب رقم $1$ يتم حسابها كما يلي:

* أوقات الوصول المتوقعة للمحطة $1$:
  - الباص $0$: $e_{0,1} = t_{0,0} + W[0] \cdot (S[1]-S[0]) = 20 + 5 \cdot 1
 = 25$.
  - الباص $1$: $e_{1,1} = t_{1,0} + W[1] \cdot (S[1]-S[0]) = 10 + 20 \cdot
 1 = 30$.
  - الباص $2$: $e_{2,1} = t_{2,0} + W[2] \cdot (S[1]-S[0]) = 40 + 20 \cdot
 1 = 60$.
  - الباص $3$: $e_{3,1} = t_{3,0} + W[3] \cdot (S[1]-S[0]) = 0 + 30 \cdot 1
 = 30$.
* أوقات الوصول للمحطة $1$:
  - الباصين $1$ و $3$ يصلان إلى المحطة أبكر من الباص $0$  $0$, لذلك 
$t_{0,1} = \max([e_{0,1},e_{1,1},e_{3,1}]) = 30$.
  - الباص $3$ يصل إلى المحطة $0$ أبكر من الباص $1$, لذلك $t_{1,1} = 
\max([e_{1,1},e_{3,1}]) = 30$.
  - الباص $0$, والباص $1$ والباص $3$ يصلون إلى محطة الترتيب $0$ أبكر من الباص $2$, لذلك $t_{2,1} = \max([e_{0,1},e_{1,1},e_{2,1},e_{3,1}]) = 
60$.
  - لا يصل أي باص إلى المحطة $0$ أبكر من الباص $3$, لذلك $t_{3,1} = 
\max([e_{3,1}]) = 30$.

```
arrival_time(0)
```

الباص $4$ يحتاج $10$ثواني ليقطع $1$ كيلومتر وهو الآن مجدول ليغادر المطار في الوقت 
 $0$.
 في هذه الحالة الجدول التالي يعرض أوقات وصول كل باص من الباصات.تم وضع خط تحت التغيير الوحيد على أوقات الوصول المتوقعة والحقيقية للباصات غير الاحتياطية

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:-----------------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $\underline{60}$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$
$4$ || $0$       || $10$      | $10$      || $30$      | $30$      || $60$      | $60$

يمكننا أن نجد أن الباص رقم $4$ يصل إلى الفندق في الثانية $60$.
وهكذا يجب على الإجرائية أن تعيد $60$.

```
arrival_time(50)
```

الباص رقم $4$ هو الآن مجدول ليغادر المطار في التوقيت $50$.
في هذه الحالة، لا يوجد أي تغيير على أوقات الوصول للباصات غير الاحتياطية مقارنة بالجدول الأولي. أوقات الوصول معروضة في الجدول التالي:

$i$ || $t_{i,0}$ || $e_{i,1}$ | $t_{i,1}$ || $e_{i,2}$ | $t_{i,2}$ || $e_{i,3}$ | $t_{i,3}$
:--:||:---------:||:---------:|:---------:||:---------:|:---------:||:---------:|:---------:
$0$ || $20$      || $25$      | $30$      || $40$      | $40$      || $55$      | $55$
$1$ || $10$      || $30$      | $30$      || $70$      | $70$      || $130$     | $130$
$2$ || $40$      || $60$      | $60$      || $100$     | $100$     || $160$     | $180$
$3$ || $0$       || $30$      | $30$      || $90$      | $90$      || $180$     | $180$
$4$ || $50$      || $60$      | $60$      || $80$      | $90$      || $120$     | $130$

الباص $4$ يتجاوز الباص الأبطأ منه رقم $2$ في محطة الترتيب $1$ 
حيث أنهما يصلان في نفس الوقت ، بعذ ذلك تتم عرقلة الباص $4$ من قبل الباص $3$ بين المحطتين $1$ و $2$ مما يجعل الباص $4$ يصل إلى المحطة $2$ في الثانية $90$ بدلاً من $80$. بعد مغادرة المحطة $2$ يتم عرقلة الباص $4$ من قبل الباص $1$ حتى يصلان معاً إلى الفندق. الباص $4$ يصل إلى الفندق في الثانية $130$ وهكذا يجب على الإجرائية أن تعيد $130$.

يمكننا رسم الأوقات التي يحتاجها كل باص للوصول في كل مسافة من المطار: المحور x من الرسم يمثل المسافة من المطار بالكيلومتر والمحور y يمثل الوقت بالثانية.
تمثل الخطوط العمودية المخططة (dashed) مواقع محطات الترتيب. الخطوط المستقيمة المستمرة المختلفة والمرفقة مع أرقام الباصات يمثل كل منها باصاً غير احتياطياً، ويمثل الخط المتقطع الباص الاحتياطي.


 `arrival_time(0)`               | `arrival_time(50)`
:-------------------------------:|:------------------------------:
![](overtaking-query1-new.png)   | ![](overtaking-query2-new.png)

## الحدود

* $1 \le L \le 10^9$
* $1 \le N \le 1\,000$
* $0 \le T[i] \le 10^{18}$ (من أجل $i$ حيث $0 \le i \lt N$)
* $1 \le W[i] \le 10^9$ (من أجل $i$ حيث $0 \le i \lt N$)
* $1 \le X \le 10^9$
* $2 \le M \le 1\,000$
* $0 = S[0] \lt S[1] \lt \cdots \lt S[M-1] = L$
* $1 \le Q \le 10^6$
* $0 \le Y \le  10^{18}$

## المسائل الجزئية

1. (9 نقاط) $N = 1, Q \le 1\,000$
1. (10 نقاط) $M = 2, Q \le 1\,000$
1. (20 نقطة) $N, M, Q \le 100$
1. (26 نقطة) $Q \le 5\,000$
1. (35 نقطة) لا يوجد أي قيود إضافية.

## Sample Grader

The sample grader reads the input in the following format:

\* line $1$: $L \; N \; X \; M \; Q$
\* line $2$: $T[0] \; T[1] \; \ldots \; T[N-1]$
\* line $3$: $W[0] \; W[1] \; \ldots \; W[N-1]$
\* line $4$: $S[0] \; S[1] \; \ldots \; S[M-1]$
\* line $5 + k$ ($0 \le k \lt Q$): $Y$ for question $k$

The sample grader prints your answers in the following format:

\* line $1 + k$ ($0 \le k \lt Q$): the return value of `arrival_time` for
 question $k$




